var xsbHistoryMgr = {

  init : function () {
    window.removeEventListener("load", xsbHistoryMgr.init, true);
    gSearchBox = document.getElementById("xsb-searchField");
    gClearButton = document.getElementById("clearSearch");
    xsbHistoryMgr.initSettings();
    xsbHistoryMgr.addPrefObserver();
    xSidebar.extensionStartup();
  },

  initSettings : function () {
    var showsearchbar = gPref.getBoolPref("extensions.xsidebar.history.manager.showsearchbar");
    var showadvanced = gPref.getBoolPref("extensions.xsidebar.history.manager.showadvancedsearch");
    xSidebar.showItem("xsb-history-searchbar", showsearchbar);
    xSidebar.showItem("xsb-advancedsearch-box", showadvanced);
  },

  unload : function () {
    xsbHistoryMgr.removePrefObserver();
  },

  searchHistoryManager : function (aInput) {
    xsbHistory.setClearButton(aInput);
    if (aInput == "") {
      xsbHistory.GroupBy(gHistoryGrouping);
      return;
    }
    else if (!xsbHistoryMgr.advancedSearchMode()) {
      xsbHistory.GroupBy("find:datasource=history&match=Name&method=contains&text=" + encodeURIComponent(aInput));     
    }
    else {
      var match = document.getElementById("xsb-matchList");
      var method = document.getElementById("xsb-methodList");
      var searchURI = "find:datasource=history"
      searchURI += "&match=" + match.selectedItem.value;
      searchURI += "&method=" + method.selectedItem.value;
      searchURI += "&text=" + encodeURIComponent(aInput);
      xsbHistory.GroupBy(searchURI);     
    }
  },

  advancedSearchMode : function (isAdvanced) {
    var advbox = document.getElementById("xsb-advancedsearch-box");
    if (isAdvanced != null) {
      advbox.hidden = !isAdvanced;
    }
    return !advbox.hidden;
  },

  /// Preferences

  prefObserver : {
    observe: function(subject, topic, data) {
    // subject is the nsIPrefBranch we're observing (after appropriate QI)
    // data is the name of the pref that's been changed (relative to subject)
      if(topic == "nsPref:changed")
        xsbHistoryMgr.initSettings();
    }
  },

  addPrefObserver : function () {
    xSidebar.prefBranch.addObserver("extensions.xsidebar.history.manager.", xsbHistoryMgr.prefObserver, false);
  },

  removePrefObserver : function () {
    if (!xSidebar.prefBranch) return;
    xSidebar.prefBranch.removeObserver("extensions.xsidebar.history.manager.", xsbHistoryMgr.prefObserver);
  }

}

window.addEventListener("load", xsbHistoryMgr.init, true);
window.addEventListener("unload", xsbHistoryMgr.unload, true);
