var gSearchBox;
var gClearButton;

if (!gPref) {
  var gPref = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefBranch)
                        .QueryInterface(Components.interfaces.nsIPrefBranch);
}

var xsbHistory = {

  panelInit : function () {
    window.removeEventListener("load", xsbHistory.panelInit, true);
    gSearchBox = document.getElementById("search-box");
    gClearButton = document.getElementById("clearSearch");
  },

  /// From Firefox
  searchHistory : function (aInput) {
    xsbHistory.setClearButton(aInput);
    if (aInput == "") {
      xsbHistory.GroupBy(gHistoryGrouping);
      return;
    }
    xsbHistory.GroupBy("find:datasource=history&match=Name&method=contains&text=" + encodeURIComponent(aInput));     
  },

  GroupBy : function (groupingType) {
    var isFind = (groupingType.substr(0, 5) == "find:");
    if (!isFind) {
      gHistoryGrouping = groupingType;
      gSearchBox.value = "";
    }
    switch(groupingType) {
      case "site":
        gHistoryTree.setAttribute("ref", "NC:HistoryRoot");
        break;
      case "dayandsite":
        gHistoryTree.setAttribute("ref", "NC:HistoryByDateAndSite");
        break;
      case "visited":
        gHistoryTree.setAttribute("ref", "NC:HistoryRoot");
        break;
      case "lastvisited":
        gHistoryTree.setAttribute("ref", "NC:HistoryRoot");
        break;
      case "day":
        gHistoryTree.setAttribute("ref", "NC:HistoryByDate");
        break;
      default:
        gHistoryTree.setAttribute("ref", groupingType);
    }
    switch(isFind? gHistoryGrouping : groupingType) {
      case "site":
      case "dayandsite":
      case "day":
        xsbHistory.SortBy("name");
        break;
      case "lastvisited":
        xsbHistory.SortBy("lastvisited");
        break;
      case "visited":
        xsbHistory.SortBy("visited");
        break;
    }
  },

  SortBy : function (sortKey) {
  // We set the sortDirection to the one before we actually want it to be in the
  // cycle list, since cycleHeader cycles it forward before doing the sort.

    var sortDirection;
    switch(sortKey) {
      case "visited":
        sortKey = "rdf:http://home.netscape.com/NC-rdf#VisitCount";
        sortDirection = "ascending";
        break;
      case "name":
        sortKey = "rdf:http://home.netscape.com/NC-rdf#Name?sort=true";
        sortDirection = "natural";
        break;
      case "lastvisited":
        sortKey = "rdf:http://home.netscape.com/NC-rdf#Date";
        sortDirection = "ascending";
        break;
      default:
        return;    
    }
    var col = document.getElementById("Name");
    col.setAttribute("sort", sortKey);
    col.setAttribute("sortDirection", sortDirection);
    var column = gHistoryTree.columns.getColumnFor(col);
    gHistoryTree.view.cycleHeader(column);
  },

  /// From AIOS
  clearSearch : function() {
    gSearchBox.value = "";
    gSearchBox.focus();
    xsbHistory.searchHistory(gSearchBox.value);
  },

  /// xSidebar additions
  setClearButton : function (aInput) {
    gClearButton.setAttribute("disabled", (aInput == "") ? "true" : "false");
  }
  
}
